<?php
/*

 Info for WordPress:
 ==============================================================================
 Plugin Name: podPress
 Version: 1.4
 Plugin URI: http://www.mightyseek.com/podpress/
 Description: The podPress pluggin gives you everything you need in one easy plugin to use WordPress for Podcasting. Set it up in <a href="options-general.php?page=podpress.php">'Options'-> podPress</a>. If you this plugin works for you, send us a comment</a>.
 Author: Dan Kuykendall (Seek3r)
 Author URI: http://www.mightyseek.com/


 podPress - Podcasting made easy for WordPress
 ==============================================================================
 
 This plugin makes it much easier and organized to use WordPress for Podcasting.

 The plugin was created as a way for me to merge Garrick Van Buren's  WP-iPodCatter 
 and Martin Laine's Audio Player with some hacks I made to Word Press 2.0. 
 I had tweaked the player to have the [audio:filename.mp3] entry to drive the 
 whole podcasting need. In the rss2.php I had tweaked it to generate the 
 enclosure tag from it. So thats how the plugin took birth, and I have been adding
 features to make the process cleaner over time.
 
 Feel free to visit my website under www.mightyseek.com or contact me at
 dan [at] kuykendall [dot] org
 
 Have fun!    
   
 Installation:
 ==============================================================================
 1. Upload the full directory into your wp-content/plugins directory
 2. Replace wp-rss2.php and 
 2. Activate it in the Plugin options
 3. Edit or publish a post or click on Rebuild Sitemap on the Sitemap Administration Interface

 
 Contributors:
 ==============================================================================
 Developer              Dan Kuykendall      http://www.mightyseek.com/

 Audio player           Martin Laine        http://www.1pixelout.net
 WP-iPodCatter          Garrick Van Buren   http://garrickvanburen.com/
 
 Thanks to all contributors and bug reporters! :)
 
 
 Release History:
 ==============================================================================
 Instead of maintaining the history in here, Im just going to maintain it at
 http://www.mightyseek.com/podpress/changelog/
 
 Todo:
 ==============================================================================
 - Add easy upload functionality
 - Get a better handle on what comment-casting is all about.

 License:
 ==============================================================================

    Copyright 2006  Dan Kuykendall  (email : dan@kuykendall.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
			
if(is_plugin_page()) { 
	$GLOBALS['podPress']->showConfig(); 
} else {

	class podPress {
		var $playerOptions = array();
		var $settings = array();
		var $podcastTag_regexp = "/\[podcast:([^]]+)]/";

		/*************************************************************/
		/* Load up the plugin values and get ready to action         */
		/*************************************************************/
		function podPress()
		{
			/* Check for / Initialize basic settings */
			if (!(get_option('podPress_version')) && !get_option('podPress_audioWebPath')) {
				$this->init();
			}

			$this->settings['audioWebPath'] = get_option('podPress_audioWebPath');			
			$this->settings['audioFilePath'] = get_option('podPress_audioFilePath');
					
			if(empty($this->settings['audioFilePath']) || $this->settings['audioFilePath'] == '' || !file_exists($this->settings['audioFilePath'])) {
				$this->settings['autoDetectedaudioFilePath'] = substr(str_replace('wp-admin', '', getcwd()), 0, -1).$this->settings['audioWebPath']	;

				if(!file_exists($this->settings['autoDetectedaudioFilePath'])) {
					$this->settings['autoDetectedaudioFilePath'] = 'Auto Detection Failed.';
				}
			}
			
			$this->settings['playerURL'] = get_settings('siteurl') . '/wp-content/plugins/podpress/player.swf';

			$this->playerOptions['bg'] = get_option("podPress_player_bgcolor");
			$this->playerOptions['leftbg'] = get_option("podPress_player_leftbgcolor");
			$this->playerOptions['lefticon'] = get_option("podPress_player_lefticoncolor");
			$this->playerOptions['rightbg'] = get_option("podPress_player_rightbgcolor");
			$this->playerOptions['rightbghover'] = get_option("podPress_player_rightbghovercolor");
			$this->playerOptions['righticon'] = get_option("podPress_player_righticoncolor");
			$this->playerOptions['righticonhover'] = get_option("podPress_player_righticonhovercolor");
			$this->playerOptions['text'] = get_option("podPress_player_textcolor");
			$this->playerOptions['slider'] = get_option("podPress_player_slidercolor");
			$this->playerOptions['track'] = get_option("podPress_player_trackcolor");
			$this->playerOptions['border'] = get_option("podPress_player_bordercolor");
			$this->playerOptions['loader'] = get_option("podPress_player_loadercolor");

			$this->settings['itunesFeedURL'] = get_option('itunesFeedURL');
			if(empty($this->settings['itunesFeedURL'])) {
				$this->settings['itunesFeedURL'] = get_settings('siteurl').'/&feed=rss2';
			}
			$this->settings['itunesFeedID'] = get_option('itunesFeedID');
			$this->settings['itunesAdminName'] = get_option('itunesAdminName');
			$this->settings['itunesAdminEmail']  = get_option('itunesAdminEmail');
			$this->settings['itunesTTL']  = get_option('itunesTTL');
			$this->settings['blogdescription'] = get_option('blogdescription');			
			$this->settings['itunesSubtitle'] = get_option('itunesSubtitle');
			$this->settings['itunesDefaultExplicit']  = get_option('itunesDefaultExplicit');
			$this->settings['itunesCategory1'] = get_option('itunesCategory1');
			$this->settings['itunesCategory2'] = get_option('itunesCategory2');
			$this->settings['itunesCategory3'] = get_option('itunesCategory3');

	
			$this->settings['itunesUseKeyword']  = get_option('itunesUseKeyword');
			$this->settings['itunesFeedKeywords']  = get_option('itunesFeedKeywords');
			
			$this->settings['itunesImageBig']  = get_option('itunesImageBig');
			$this->settings['itunesImageSmall']  = get_option('itunesImageSmall'); 

			$this->settings['channelCat']  = get_option('channelCat'); 

			if ($this->settings['itunesCommentCast'] == "yes") {
				$this->settings['itunesCommentCast'] = 'checked="checked"';
			}
		}

		/*************************************************************/
		/* Handle all the default values for a new install of plugin */
		/*************************************************************/
		function init() {
			add_option('podPress_version', '1.4');
			if(get_option('podPress_audioWebPath') == '')
			{
				add_option('podPress_audioWebPath', '/audio', "Web path to Podcast audio files", true);
			}

			if(get_option('podPress_player_bgcolor') == '')	{
				add_option('podPress_player_bgcolor', '0xf8f8f8', "Background color", true);
				add_option('podPress_player_textcolor', '0x666666', "Text color", true);
				add_option('podPress_player_leftbgcolor', '0xeeeeee', "Left background color", true);
				add_option('podPress_player_lefticoncolor', '0x666666', "Left icon color", true);
				add_option('podPress_player_rightbgcolor', '0xcccccc', "Right background color", true);
				add_option('podPress_player_rightbghovercolor', '0x999999', "Right background hover color", true);
				add_option('podPress_player_righticoncolor', '0x666666', "Right icon color", true);
				add_option('podPress_player_righticonhovercolor', '0xffffff', "Right icon hover color", true);
				add_option('podPress_player_slidercolor', '0x666666', "Progress slider color", true);
				add_option('podPress_player_trackcolor', '0xFFFFFF', "Progress track color", true);
				add_option('podPress_player_loadercolor', '0x9FFFB8', "Loader bar color", true);
				add_option('podPress_player_bordercolor', '0x666666', "Border color", true);
			}
		}
		
		function get($varname = '##NOTSET##')
		{
			if (isset($this->settings[$varname])) {
				return $this->settings[$varname];
			}
			return false;
		}
		
		function getTags($varname, $input = false)
		{
			global $wpdb, $tablepostmeta;		
			$result = '';

			switch($varname) {
				case 'enclosure':
					$mp3name = $this->getMp3FromPodcastTag($input);
					$lengthAttrib = '';
					if($mp3name) {
						if(preg_match( '/^(http|https):/i' ,$mp3name)) {
							$fullMp3Url = $mp3name;
						} else {
							$fullMp3Path = $GLOBALS['podPress']->settings['audioFilePath'].'/'.$mp3name;
							$fullMp3Url = get_settings('siteurl').$GLOBALS['podPress']->settings['audioWebPath'].'/'.$mp3name;
							if (file_exists($fullMp3Path))
							{
								$lengthAttrib = ' length="'.filesize ($fullMp3Path).'"';
							}
						}
						$result .= '<enclosure url="'.$fullMp3Url.'"'.$lengthAttrib.' type="audio/mpeg"/>'."\n";	
					}
					break;
				case 'itunesKeywords':
					if (get_option('itunesUseKeyword')) {
						$value = $wpdb->get_var(
							"SELECT meta_value FROM $tablepostmeta ".
							"WHERE post_ID = '$input' ".
							"AND meta_key = 'itunes:keywords'"
						);
						$allkeys = $value;	
					} else {
						$categories = get_the_category();
						foreach ($categories as $category) {
							$category->cat_name = convert_chars($category->cat_name);
							$allkeys = $allkeys . $category->cat_name . ",";			
						}
						$allkeys = trim($allkeys);
					}
					$result = '<itunes:keywords>'.$allkeys.'</itunes:keywords>'."\n";	
					break;
				case 'itunesExplicit':
					$value = $wpdb->get_var(
						"SELECT meta_value FROM $tablepostmeta ".
						"WHERE post_ID = '$input' ".
						"AND meta_key = 'itunes:explicit'"
					);

					if ($value) {
						$result =  '<itunes:explicit>'.$value.'</itunes:explicit>'."\n";
					} else {
						$result =  '<itunes:explicit>'.$this->settings['itunesDefaultExplicit'].'</itunes:explicit>'."\n";
					}
					break;
				case 'itunesBlock':
					$value = $wpdb->get_var(
						"SELECT meta_value FROM $tablepostmeta ".
						"WHERE post_ID = '$input' ".
						"AND meta_key = 'itunes:block'"
					);	
					if ($value) {
						$result =  '<itunes:block>Yes</itunes:block>'."\n";
					} else {
						$result =  '<itunes:block>No</itunes:block>'."\n";
					}
					break;
				case 'itunesDuration':
					$theDur = "";
					$hasDur = $wpdb->get_var("SELECT meta_value FROM $tablepostmeta ". "WHERE post_ID = '$input' ". "AND meta_key = 'itunes:duration'" );	
	
					// test for empty
					if ( $hasDur AND $hasDur != '' AND isset( $hasDur ) ) { $theDur = "<itunes:duration>".$hasDur."</itunes:duration>"."\n"; } 	
					$result =  $theDur;
					break;
				case 'itunesCategory':
					$result = '';
					$thiscat = get_option('itunesCategory1');
					if(!empty($thiscat))
					{
						if(strstr($thiscat, ':')) {
							list($cat, $subcat) = explode(":", $thiscat);
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $cat).'">'."\n";
							$result .= '  <itunes:category text="'.str_replace('&', '&amp;', $subcat).'"/>'."\n";
							$result .= '</itunes:category>'."\n";
						}
						else
						{
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $thiscat).'"/>'."\n";
						}
					}
					$thiscat = get_option('itunesCategory2');
					if(!empty($thiscat))
					{
						if(strstr($thiscat, ':')) {
							list($cat, $subcat) = explode(":", $thiscat);
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $cat).'">'."\n";
							$result .= '  <itunes:category text="'.str_replace('&', '&amp;', $subcat).'"/>'."\n";
							$result .= '</itunes:category>'."\n";
						}
						else
						{
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $thiscat).'"/>'."\n";
						}
					}
					$thiscat = get_option('itunesCategory3');
					if(!empty($thiscat))
					{
						if(strstr($thiscat, ':')) {
							list($cat, $subcat) = explode(":", $thiscat);
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $cat).'">'."\n";
							$result .= '  <itunes:category text="'.str_replace('&', '&amp;', $subcat).'"/>'."\n";
							$result .= '</itunes:category>'."\n";
						}
						else
						{
							$result .= '<itunes:category text="'.str_replace('&', '&amp;', $thiscat).'"/>'."\n";
						}
					}

					break;
				default:
					$result = '';
			}
			return $result;
		}
		
		/*************************************************************/
		/* Process updates to the configs                            */
		/*************************************************************/
		function process()
		{
			// settings for the player
			if(isset($_POST['podPress_audioWebPath'])) {
				if(substr($_POST['podPress_audioWebPath'], -1 ) == '/')
				{
					$_POST['podPress_audioWebPath'] = substr( $_POST['podPress_audioWebPath'], 0, -1);
				}
				update_option('podPress_audioWebPath', $_POST['podPress_audioWebPath']); 
			}

			if(isset($_POST['podPress_audioFilePath'])) {
				//if(substr($_POST['podPress_audioFilePath'], -1 ) == '/' || substr($_POST['podPress_audioFilePath'], -1 ) == '\\')
				//{
				//	$_POST['podPress_audioFilePath'] = substr($_POST['podPress_audioFilePath'], 0, -1);
				//}
				update_option('podPress_audioFilePath', $_POST['podPress_audioFilePath']); 
			}

			if(isset($_POST['itunesFeedURL'])) { update_option('itunesFeedURL', $_POST['itunesFeedURL']); }
			if(isset($_POST['itunesFeedID'])) { update_option('itunesFeedID', $_POST['itunesFeedID']); }
			if(isset($_POST['itunesAdminName'])) { update_option('itunesAdminName', $_POST['itunesAdminName']); }
			if(isset($_POST['itunesAdminEmail'])) { update_option('itunesAdminEmail', $_POST['itunesAdminEmail']); }
			if(isset($_POST['itunesTTL'])) { update_option('itunesTTL', $_POST['itunesTTL']); }
			if(isset($_POST['itunesSubtitle'])) { update_option('itunesSubtitle', $_POST['itunesSubtitle']); }
			if(isset($_POST['itunesUseKeyword'])) { update_option('itunesUseKeyword', $_POST['itunesUseKeyword']); }
			if(isset($_POST['itunesFeedKeywords'])) { update_option('itunesFeedKeywords', $_POST['itunesFeedKeywords']); }
			if(isset($_POST['channelCat'])) { update_option('channelCat', $_POST['channelCat']); }

			if(isset($_POST['itunesCategory1']) && $_POST['itunesCategory1'] != '#') {
				update_option('itunesCategory1',  $_POST['itunesCategory1']); 
			}

			if(isset($_POST['itunesCategory2']) && $_POST['itunesCategory2'] != '#') {
				update_option('itunesCategory2',  $_POST['itunesCategory2']); 
			}

			if(isset($_POST['itunesCategory3']) && $_POST['itunesCategory3'] != '#') {
				update_option('itunesCategory3',  $_POST['itunesCategory3']); 
			}
	
			if(isset($_POST['itunesImageBig'])) { update_option('itunesImageBig', $_POST['itunesImageBig']); }
			if(isset($_POST['itunesImageSmall'])) { update_option('itunesImageSmall', $_POST['itunesImageSmall']); } 	
	
			$commentcast = isset( $_POST['itunesCommentCast'] ) ?
				   $_POST['itunesCommentCast'] :
				   array();
				   
			if(count($commentcast) > 0) { 
				update_option('itunesCommentCast', 'yes'); 
			} else {
				update_option('itunesCommentCast', 'no');	 
			}
	
			if(isset($_POST['itunesDefaultExplicit'])) { update_option('itunesDefaultExplicit', $_POST['itunesDefaultExplicit']); }

			update_option('podPress_player_bgcolor', str_replace("#", "0x", $_POST['podPressPlayer_bgcolor']));
			update_option('podPress_player_leftbgcolor', str_replace("#", "0x", $_POST['podPressPlayer_leftbgcolor']));
			update_option('podPress_player_rightbgcolor', str_replace("#", "0x", $_POST['podPressPlayer_rightbgcolor']));
			update_option('podPress_player_rightbghovercolor', str_replace("#", "0x", $_POST['podPressPlayer_rightbghovercolor']));
			update_option('podPress_player_lefticoncolor', str_replace("#", "0x", $_POST['podPressPlayer_lefticoncolor']));
			update_option('podPress_player_righticoncolor', str_replace("#", "0x", $_POST['podPressPlayer_righticoncolor']));
			update_option('podPress_player_righticonhovercolor', str_replace("#", "0x", $_POST['podPressPlayer_righticonhovercolor']));
			update_option('podPress_player_textcolor', str_replace("#", "0x", $_POST['podPressPlayer_textcolor']));
			update_option('podPress_player_slidercolor', str_replace("#", "0x", $_POST['podPressPlayer_slidercolor']));
			update_option('podPress_player_trackcolor', str_replace("#", "0x", $_POST['podPressPlayer_trackcolor']));
			update_option('podPress_player_loadercolor', str_replace("#", "0x", $_POST['podPressPlayer_loadercolor']));
			update_option('podPress_player_bordercolor', str_replace("#", "0x", $_POST['podPressPlayer_bordercolor']));

			$location = get_option('siteurl') . '/wp-admin/admin.php?page=podpress.php';
			header('Location: '.$location);
			exit;
		}

		/*************************************************************/
		/* Load up the plugin values and get ready to action         */
		/*************************************************************/
		function replace($matches)
		{
			$data = preg_split("/[\|\]/", $matches[1]);
			$file = $data[0];
			$fileparts = explode("/", $file);
			$fileName = $fileparts[count($fileparts)-1];

			if(!preg_match( '/^(http|https):/i' ,$file)) {
				$file = $this->settings['audioWebPath'] . "/" . $file;
			}
			
			if(!preg_match( '/^(http|https):/i' ,$file)) {
				$file = get_settings('siteurl').$file;
			}
			
			$options = $this->playerOptions;
			$i = 1;
			for($i=1;$i<count($data);$i++)
			{
				$pair = explode("=", $data[$i]);
				$options[$pair[0]] = $pair[1]; 
			}
			$url = $this->settings['playerURL'] . '?soundFile=' . rawurlencode($file);
			foreach($options as $key => $value)
			{
				$url .= '&amp;' . $key . '=' . rawurlencode($value);
			}
	
			if(is_feed())
			{
				return '<a href="' . $file . '">Download ' . $fileName . '</a>';
			}
			else
			{
				return 'Listen now: <br/><object type="application/x-shockwave-flash" data="' . $url . '" width="290" height="24"><param name="movie" value="' . $url . '" /><param name="quality" value="high" /><param name="menu" value="false" /><param name="wmode" value="transparent" /><a href="' . $file . '">Download ' . $fileName . '</a></object><br/>or <a href="' . $file . '">Download directly</a>'; 
			}
		}

		function getMp3FromPodcastTag($haystack) {
			if(preg_match($this->podcastTag_regexp, $haystack, $matches))
			{
				return $matches[1];
			}
			return false;
		}

		/*************************************************************/
		/* Load up the plugin values and get ready to action         */
		/*************************************************************/
		function insert_player_widgets($content = '')
		{
			return preg_replace_callback( $this->podcastTag_regexp, "podPress_replace", $content ); 
		}
	
		/*************************************************************/
		/* Output HTML to render Config page                         */
		/*************************************************************/

		function save_post($post_id) {  
			if ($_POST['itunesExplicit']) { $itunesExplicit = $_POST['itunesExplicit']; }
			if ($_POST['itunesBlock']) { $itunesBlock = "yes"; } else { $itunesBlock = "no";  }
			if ($_POST['itunesKeywords']) { $itunesKeywords = $_POST['itunesKeywords']; }
			if ($_POST['itunesCat']) { $itunesCat = $_POST['itunesCat']; }

			if ($_POST['content']) {
				$mp3name = $this->getMp3FromPodcastTag($_POST['content']);

				if($mp3name) {
					$fullMp3Path = $GLOBALS['podPress']->settings['audioFilePath'].'/'.$mp3name;
					if (file_exists($fullMp3Path))
					{
						include_once('podpress/id3v2.php');
						$id3Reader = new id3v2();
						$id3Reader->GetInfo($fullMp3Path);
						$itunesDur = $id3Reader->sec2hms($id3Reader->mpegInfo['PlaySeconds']);
					}
				}
			}
			
			$this->meta_update($post_id, $itunesCat, $itunesExplicit, $itunesDur, $itunesKeywords, $itunesBlock);
		}
		
		function showConfig() {

			// I normally hate doing it this way, but I want to use vi's syntax highlighting, so Im taking an ugly shortcut and
			// exiting php to just include as needed
	?>
<div class="wrap">
	<h2>Podcasting Options</h2>
	<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">

	<fieldset class="options">
		<legend>General Podcasting Options</legend>
		<table width="100%" cellspacing="2" cellpadding="5" class="editform">
			<tr>
				<th width="33%" valign="top"><label for="podPress_audioWebPath">URI of audio files directory:</label></th>
				<td>
					<input type="text" id="podPress_audioWebPath" name="podPress_audioWebPath" size="40" value="<?php echo( $this->settings['audioWebPath'] ); ?>" />
						<br/>Can be local or remote location.
					<?php 
						if(!isset($this->settings['audioWebPath']) || empty($this->settings['audioWebPath'])){
							echo "<br />\n";
							echo 'Recommended: <code>/audio</code>'."\n";
						}
					?>
					
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPress_audioFilePath">Local path to audio files directory (optional):</label></th>
				<td>
					<input type="text" id="podPress_audioFilePath" name="podPress_audioFilePath" size="40" value="<?php echo $this->settings['audioFilePath']; ?>" /><br />
						Used to get the MP3 file sizes content duration.
					<?php 
						if(isset($this->settings['autoDetectedaudioFilePath'])){
							echo "<br/>\n";
							echo 'Directory Not Valid or Not Accessible<br/> Suggested: <code>'.$this->settings['autoDetectedaudioFilePath'].'</code>'."\n";
						}
					?>
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPress_Description">Blog/Podcast Description</label></th>
				<td><textarea type="text" name="blogdescription" max="255" id="blogdescription" rows="4" cols="40"><?php echo $this->settings['blogdescription']; ?></textarea><br />(Used as iTunes description)</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label>Podcast Cover Image URLs:</label></th>
				<td>
					<table width="100%" cellspacing="2" cellpadding="5" class="editform">
						<tr valign="top"> 
							<td>
								<b>Big (300*300 pixels)</b><br/>
								<input type="text" name="itunesImageBig" value="<?php if ($this->settings['itunesImageBig']) { echo $this->settings['itunesImageBig']; } else { echo get_settings('siteurl'); } ?>" size="40" />
								<?php if ($this->settings['itunesImageBig']) { ?><br /><img src="<?php echo $this->settings['itunesImageBig']; ?>" width="300" height="300" alt="Podcast Image - Big"/><?php } ?>
							</td>
						</tr>
						<tr valign="top"> 
							<td>
								<b>Small (144*144 pixels)</b><br/>
								<input type="text" name="itunesImageSmall" value="<?php if ($this->settings['itunesImageSmall']) { echo $this->settings['itunesImageSmall']; } else { echo get_settings('siteurl'); } ?>" size="40" />
								<?php if ($this->settings['itunesImageSmall']) { ?><br /><img src="<?php echo $this->settings['itunesImageSmall']; ?>" width="144" height="144" alt="Podcast Image - Small"/><?php } ?>
							</td>
						</tr>
					</table>
				</td>
			</tr>

			
			<tr valign="top"> 
				<th width="33%" scope="row">Channel Category</th> 
				<td><input name="channelCat" type="text" id="channelCat" value="<?php echo $this->settings['channelCat']; ?>" size="45%" /><br />Anything you want. This is for everyone except iTunes.</td>
			</tr>
			
			<tr valign="top">
				<th width="33%" scope="row">Comments Feed Podcast</th> 
				<td><input type="checkbox" name="itunesCommentCast" id="itunesCommentCast" <?php echo $this->settings['itunesCommentCast']; ?> /> Yeah, I'm comment-casting. <em>(Use the replacement wp-commentsrss2.php file)</em></td>
			</tr> 
		</table>
	</fieldset>

	<p class="submit"> 
	<input type="submit" name="Submit" value="Update Options &raquo;" /> 
	</p> 

	<fieldset class="options">
		<legend>iTunes Options</legend>
<script><!--
if(!self.getHTTPObject){
function getHTTPObject() {

  var xmlhttp;

  /*@cc_on

  @if (@_jscript_version >= 5)

    try {

      xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");

    } catch (e) {

      try {

        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");

      } catch (E) {

        xmlhttp = false;

      }

    }

  @else

  xmlhttp = false;

  @end @*/

  if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {

    try {

      xmlhttp = new XMLHttpRequest();

    } catch (e) {

      xmlhttp = false;

    }

  }

  return xmlhttp;

}

}
var iTunesHttp = getHTTPObject(); // We create the HTTP Object

function handleiTunesHttpResponse() {
  if (iTunesHttp.readyState == 4) {
		alert(iTunesHttp.responseText);
		document.getElementById('iTunesPingResult').style.visibility="visible";
  }
}

function pingITunesUpdate() {
	var url = 'https://phobos.apple.com/WebObjects/MZFinance.woa/wa/pingPodcast?';
	if(document.getElementById('itunesFeedID').value != ''){
		var params = 'id='+document.getElementById('itunesFeedID').value;
	} else {
		var params = 'feedURL='+document.getElementById('itunesFeedURL').value;
	}
  iTunesHttp.open("GET", url + params, true);
  iTunesHttp.onreadystatechange = handleiTunesHttpResponse;
  iTunesHttp.send(null);
}

-->
</script>
		<table width="100%" cellspacing="2" cellpadding="5" class="editform">

			<tr valign="top"> 
				<th width="33%" scope="row">iTunes:FeedURL</th>
				<td><input name="itunesFeedURL" type="text" id="itunesFeedURL" value="<?php echo stripslashes($this->settings['itunesFeedURL']); ?>" size="40" /></td> 
			</tr>

			<tr valign="top"> 
				<th width="33%" scope="row">iTunes:FeedID</th>
				<td>
					<input name="itunesFeedID" type="text" id="itunesFeedID" value="<?php echo stripslashes($this->settings['itunesFeedID']); ?>" size="10" />
						<!--<input type="button" name="Ping_iTunes_update" value="Ping iTunes Update" onClick="pingITunesUpdate()"/>-->
					<div id="iTunesPingResult" style="visibility: hidden;">Ping iTunes server to update your podcast information - Complete!</div>
				</td> 
			</tr>
			
			<tr valign="top"> 
				<th width="33%" scope="row">iTunes:Subtitle</th>
				<td><textarea type="text" name="itunesSubtitle" max="255" id="itunesSubtitle" rows="4" cols="40"><?php echo stripslashes( $this->settings['itunesSubtitle'] ); ?></textarea><br />(Used as default Podcast Episode Title)<br />(255 characters)</td>
			</tr>
			<tr valign="top">
					<th width="33%" scope="row">iTunes:Keywords</th>
				<td>
					<fieldset style="width:60%">
						<label> Keywords for the entire feed. </label><textarea name="itunesFeedKeywords" rows="4" cols="40" max="254"><?php echo stripslashes( $this->settings['itunesFeedKeywords'] ); ?></textarea>
						<br />
						Set per Post keywords:<br/>
						<label><input name="itunesUseKeyword"  type="radio" value="0" <?php if (!$this->settings['itunesUseKeyword']) { echo 'checked="checked"'; } ?> /> Using WordPress Categories</label>
						<br />
						<label><input name="itunesUseKeyword" type="radio" value="1" <?php if ($this->settings['itunesUseKeyword']) { echo 'checked="checked"'; } ?> /> By hand</label>
					</fieldset>
				</td>
			</tr>
		
			<tr valign="top">
				<th width="33%" scope="row">iTunes:Categories</th> 
				<td>
					<select name="itunesCategory1">
						<option value="#">Select Primary</option>
						<?php $this->itunesCategoryOptions($this->settings['itunesCategory1']); ?>
					</select>
					<select name="itunesCategory2">
						<option value="#">Select Second</option>
						<?php $this->itunesCategoryOptions($this->settings['itunesCategory2']); ?>
					</select>
					<select name="itunesCategory3">
						<option value="#">Select Third</option>
						<?php $this->itunesCategoryOptions($this->settings['itunesCategory3']); ?>
					</select>
				</td>
			</tr>

			<tr valign="top"> 
				<th width="33%" scope="row">Owner Name:</th> 
				<td><input name="itunesAdminName" type="text" id="itunesAdminName" value="<?php echo stripslashes($this->settings['itunesAdminName']); ?>" size="40" /></td> 
	  	</tr>
		  <tr valign="top"> 
				<th width="33%" scope="row">Owner E-mail address:</th> 
				<td><input name="itunesAdminEmail" type="text" id="itunesAdminEmail" value="<?php if ($this->settings['itunesAdminEmail']) { echo $this->settings['itunesAdminEmail']; } else { form_option('admin_email'); } ?>" size="40" /></td> 
			</tr>
			
			<tr valign="top">
				<th width="33%" scope="row">iTunes:Explicit</th>
				<td>
					<select name="itunesDefaultExplicit">
						<option value="No" <?php if($this->settings['itunesDefaultExplicit'] == 'No') { echo 'selected="selected""'; } ?>>No</option>
						<option value="Yes" <?php if($this->settings['itunesDefaultExplicit'] == 'Yes') { echo 'selected="selected""'; } ?>>Yes</option>
						<option value="Clean" <?php if($this->settings['itunesDefaultExplicit'] == 'Clean') { echo 'selected="selected""'; } ?>>Clean</option>
					</select> This defines the default that will be used. Each show can have its own Explicit rating.
				</td>
			</tr>

			<tr valign="top">
				<th width="33%" scope="row">iTunes:TTL (time-to-live)</th>
				<td><input name="itunesTTL" type="text" id="itunesTTL" value="<?php if ($this->settings['itunesTTL']) { echo $this->settings['itunesTTL']; } else { echo '1440'; } ?>" size="4" /> (Mins. Default is 24hrs which is 1440 mins)</td> 
			</tr>
		</table>
	</fieldset>

	<p class="submit"> 
	<input type="submit" name="Submit" value="Update Options &raquo;" /> 
	</p> 

	<fieldset class="options">
		<legend>iTunes Preview</legend>

		<table width="100%" cellspacing="2" cellpadding="5" class="editform" bgcolor="#C5A4E0">
			<tr valign="top">
				<td>
<?php
			if ($this->settings['itunesImageBig']) {
				$iTunesPreviewImage = $this->settings['itunesImageBig'];
			} elseif ($this->settings['itunesImageSmall']) {
				$iTunesPreviewImage = $this->settings['itunesImageSmall'];
			} else {
				$iTunesPreviewImage = 'http://www.mightyseek.com/images/iTunesDefaultImage.jpg';
			}
			echo '<img src="'.$iTunesPreviewImage.'" width="300" height="300" alt="Podcast Image"/>'."\n";
?>
				</td>
				<td>
					<b><font size="+1"><?php bloginfo_rss('name'); ?></font></b><br/>
					<?php echo stripslashes($this->settings['itunesAdminName']); ?>
					<br/>
					<br/>
					<br/>
					<br/>
					<br/>
					<font size="-1">
						Total: x episodes<br/>
						Category: <br/>
						Language: English</br>
						</br>
						<img src="http://www.mightyseek.com/images/itunes-subscribebutton.gif" border="0"/> 
					</font>
				</td>
				<td><img src="http://www.mightyseek.com/images/vert-bar.gif" border="0" width="2" height="300"/>&nbsp;</td>
				<td>
					<b><font size="+1">Podcast Description</font></b><br/>
					<font size="-1"><?php bloginfo_rss("description"); ?></font>
						</br>
						</br>
						<img src="http://www.mightyseek.com/images/iTunes_websiteandreportconcern.jpg" border="0"/> 						
				</td>
			</tr>
		</table>
	</fieldset>

	<br />

	<fieldset class="options">
		<legend>Player Colors</legend>
		<p>

		<table class="editform" cellpadding="5" cellspacing="2" width="100%">
			<tr>
				<th>Colour map:</th>
				<td><img src="<?php echo( get_settings( "siteurl" ) ); ?>/wp-content/plugins/podpress/map.gif" width="390" height="124" /></td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_bgcolor">Background:</label></th>
				<td>
					<input type="text" id="podPressPlayer_bgcolor" name="podPressPlayer_bgcolor" size="40" value="<?php echo( $this->playerOptions['bg'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_leftbgcolor">Left background:</label></th>
				<td>
					<input type="text" id="podPressPlayer_leftbgcolor" name="podPressPlayer_leftbgcolor" size="40" value="<?php echo( $this->playerOptions['leftbg'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_rightbgcolor">Right background:</label></th>
				<td>
					<input type="text" id="podPressPlayer_rightbgcolor" name="podPressPlayer_rightbgcolor" size="40" value="<?php echo( $this->playerOptions['rightbg'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_rightbghovercolor">Right background (hover):</label></th>
				<td>
					<input type="text" id="podPressPlayer_rightbghovercolor" name="podPressPlayer_rightbghovercolor" size="40" value="<?php echo( $this->playerOptions['rightbghover'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_lefticoncolor">Left icon:</label></th>
				<td>
					<input type="text" id="podPressPlayer_lefticoncolor" name="podPressPlayer_lefticoncolor" size="40" value="<?php echo( $this->playerOptions['lefticon'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_righticoncolor">Right icon:</label></th>
				<td>
					<input type="text" id="podPressPlayer_righticoncolor" name="podPressPlayer_righticoncolor" size="40" value="<?php echo( $this->playerOptions['righticon'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_righticonhovercolor">Right icon (hover):</label></th>
				<td>
					<input type="text" id="podPressPlayer_righticonhovercolor" name="podPressPlayer_righticonhovercolor" size="40" value="<?php echo( $this->playerOptions['righticonhover'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_iconcolor">Text:</label></th>
				<td>
					<input type="text" id="podPressPlayer_textcolor" name="podPressPlayer_textcolor" size="40" value="<?php echo( $this->playerOptions['text'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_slidercolor">Slider:</label></th>
				<td>
					<input type="text" id="podPressPlayer_slidercolor" name="podPressPlayer_slidercolor" size="40" value="<?php echo( $this->playerOptions['slider'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_trackcolor">Progress bar track:</label></th>
				<td>
					<input type="text" id="podPressPlayer_trackcolor" name="podPressPlayer_trackcolor" size="40" value="<?php echo( $this->playerOptions['track'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_loadercolor">Loader bar:</label></th>
				<td>
					<input type="text" id="podPressPlayer_loadercolor" name="podPressPlayer_loadercolor" size="40" value="<?php echo( $this->playerOptions['loader'] ); ?>" /><br />
				</td>
			</tr>
			<tr>
				<th width="33%" valign="top"><label for="podPressPlayer_bordercolor">Progress bar border:</label></th>
				<td>
					<input type="text" id="podPressPlayer_bordercolor" name="podPressPlayer_bordercolor" size="40" value="<?php echo( $this->playerOptions['border'] ); ?>" /><br />
				</td>
			</tr>
		</table>

		</p>
	</fieldset>

		
	<input type="hidden" name="submitted" value="submitted" />
	<p class="submit"> 
	<input type="submit" name="Submit" value="Update Options &raquo;" /> 
	</p> 
	</form> 
</div>

		<?php
			// *** end of showConfig function ***
		}	
	

		function showForm() {
			global $wpdb, $tablepostmeta;
	
			if (($_GET['action'] == 'edit')) {
				$post_id = $_GET['post'];
				$itunesKeywords = $wpdb->get_var(
					"SELECT meta_value FROM $tablepostmeta ".
					"WHERE meta_key = 'itunes:keywords' ".
					"AND post_id = '$post_id'"
				);
		
				$itunesExplicit = $wpdb->get_var(
					"SELECT meta_value FROM $tablepostmeta ".
					"WHERE meta_key = 'itunes:explicit' ".
					"AND post_id = '$post_id'"
				);
				
				if (!$itunesExplicit) {
					$itunesExplicit = $this->settings['itunesDefaultExplicit'];
				}
		
				$itunesBlock = $wpdb->get_var(
					"SELECT meta_value FROM $tablepostmeta ".
					"WHERE meta_key = 'itunes:block' ".
					"AND post_id = '$post_id'"
				);
		
				if ($itunesBlock == "yes") {
					$itunesBlock = 'checked="checked"';
				}
		
			}
			?>
			<fieldset style="width:100%"><legend><strong>iTunes Podcast Tags</strong></legend>
		
			<?php if (get_option('itunesUseKeyword')) { ?>
				<p>
					<label><strong>Keywords</strong>: Separate multiples with commas</label><br />
					<textarea name="itunesKeywords" rows="4" cols="40" max="254"><?php echo $itunesKeywords; ?></textarea>
				</p>
			<?php } ?>
			<p>
				<label><strong>Explicit</strong> (Headphones Required?)</label><br />
					<select name="itunesExplicit">
						<option value="No" <?php if($itunesExplicit == 'No') { echo 'selected="selected""'; } ?>>No</option>
						<option value="Yes" <?php if($itunesExplicit == 'Yes') { echo 'selected="selected""'; } ?>>Yes</option>
						<option value="Clean" <?php if($itunesExplicit == 'Clean') { echo 'selected="selected""'; } ?>>Clean</option>
					</select>
			</p>
			<p>
				<label><strong>Block</strong></label><br />
				<input type="checkbox" name="itunesBlock" <?php echo $itunesBlock; ?>> Hide from iTunes
			</p>
		<?
		}



		function meta_update($post_id, $itunesCat, $itunesExplicit, $itunesDur, $itunesKeywords, $itunesBlock) {
			global $wpdb, $tablepostmeta;
	
			/// EXPLICIT
			if ($itunesExplicit) {
				$oldExCheck = $wpdb->get_var(
					"SELECT meta_value FROM $tablepostmeta ".
					"WHERE meta_key = 'itunes:explicit' ".
					"AND post_id = '$post_id'"
				);
				if ($oldExCheck != $itunesExplicit) {
					$result = $wpdb->query(
						"DELETE FROM $tablepostmeta ".
						"WHERE post_id = $post_id ".
						"AND meta_key = 'itunes:explicit'"
					);
					$result = $wpdb->query(
						"INSERT INTO $tablepostmeta (".
							"post_id, meta_key, meta_value".
						") VALUES (".
							"'$post_id','itunes:explicit','$itunesExplicit'".
						")"
					);
				}
			}
			
			/// BLOCK
			if ($itunesBlock) {
				if ($itunesBlock == "no") { $itunesBlock = ""; }
		
				$oldBlCheck = $wpdb->get_var("SELECT meta_value FROM $tablepostmeta "."WHERE meta_key = 'itunes:block' "."AND post_id = '$post_id'" );

				if ($oldBlCheck && !$itunesBlock) { 
				  $result = $wpdb->query("DELETE FROM $tablepostmeta "."WHERE post_id = $post_id "."AND meta_key = 'itunes:block'"); 
        }
				if ($itunesBlock && !$oldBlCheck)  {
				  $result = $wpdb->query("INSERT INTO $tablepostmeta ("."post_id, meta_key, meta_value".") VALUES ("."'$post_id','itunes:block','$itunesBlock'". ")");
				}
			}
	

			/// DURATION --> must be set and not empty
			if ($itunesDur) {
				// get current value
				$oldDurCheck = $wpdb->get_var("SELECT meta_value FROM $tablepostmeta ". "WHERE meta_key = 'itunes:duration' ". "AND post_id = '$post_id'");

				// if we have one, update...
				if ($oldDurCheck) {
					$result = $wpdb->query("UPDATE $tablepostmeta ". "SET meta_value = '$itunesDur' ". "WHERE post_id = $post_id ". "AND meta_key = 'itunes:duration'");
		
				// otherwise insert new
				} else {
					$result = $wpdb->query("INSERT INTO $tablepostmeta (". "post_id, meta_key, meta_value". ") VALUES (". "'$post_id','itunes:duration','$itunesDur'". ")");
				}
			}

			/// KEYWORDS
			if ($itunesKeywords) {
				$oldKeyCheck = $wpdb->get_var(
					"SELECT meta_value FROM $tablepostmeta ".
					"WHERE meta_key = 'itunes:keywords' ".
					"AND post_id = '$post_id'"
				);
	
				if ($oldKeyCheck) {
					$result = $wpdb->query(
						"UPDATE $tablepostmeta ".
						"SET meta_value = '$itunesKeywords' ".
						"WHERE post_id = '$post_id' ".
						"AND meta_key = 'itunes:keywords'"
					);
				} else {
					$result = $wpdb->query(
						"INSERT INTO $tablepostmeta (".
							"post_id, meta_key, meta_value".
						") VALUES (".//comment_do_enclose
							"'".$post_id."','itunes:keywords','$itunesKeywords'".
						")"
					);
			
				}
		
			}
		}

		///// THIS IS FOR ENABLING COMMENT-PODCASTS ////
		function comment_do_enclose($comment_ID) {
			global $wp_version, $wpdb;

			$comment = $wpdb->get_var(
				"SELECT comment_content FROM $wpdb->comments ".
				"WHERE comment_ID = '$comment_ID'"
			);
	
			$post_ID = $wpdb->get_var(
				"SELECT comment_post_ID FROM $wpdb->comments ".
				"WHERE comment_ID = '$comment_ID'"
			);
		
			include_once (ABSPATH . WPINC . '/class-IXR.php');

			$log = debug_fopen(ABSPATH . '/enclosures.log', 'a');
			$post_links = array();
			debug_fwrite($log, 'BEGIN '.date('YmdHis', time())."\n");

			$pung = $this->getCommentEnclosed($comment_ID, $post_ID);

			$ltrs = '\w';
			$gunk = '/#~:.?+=&%@!\-';
			$punc = '.:?\-';
			$any = $ltrs . $gunk . $punc;

			preg_match_all("{\b http : [$any] +? (?= [$punc] * [^$any] | $)}x", $comment, $comment_links_temp);

			debug_fwrite($log, 'Comment contents:');
			debug_fwrite($log, $commentInfo->comment_content."\n");

			foreach($comment_links_temp[0] as $link_test) :
				if ( !in_array($link_test, $pung) ) : // If we haven't pung it already
					$test = parse_url($link_test);
					if (isset($test['query']))
						$comment_links[] = $link_test;
					elseif(($test['path'] != '/') && ($test['path'] != ''))
						$comment_links[] = $link_test;
				endif;
			endforeach;

			foreach ($comment_links as $url) :
				if ( $url != '' && !$wpdb->get_var("SELECT post_id FROM $wpdb->postmeta WHERE post_id = '$post_ID' AND meta_key = 'com-enclosure' AND meta_value LIKE ('$url%')") ) {
					if ( $headers = wp_get_http_headers( $url) ) {
						$len  = (int) $headers['content-length'];
						$type = addslashes( $headers['content-type'] );
						$allowed_types = array( 'video', 'audio' );
				
						if( in_array( substr( $type, 0, strpos( $type, "/" ) ), $allowed_types ) ) {
							$meta_value = "$comment_ID\n$url\n$len\n$type\n";				
							$wpdb->query( "INSERT INTO `$wpdb->postmeta` ( `post_id` , `meta_key` , `meta_value` )
							VALUES ( '$post_ID', 'com-enclosure' , '$meta_value')" );
						}
					}
				}
			endforeach;
		}


		// Get enclosures already enclosed for a comment
		function getCommentEnclosed ($comment_id, $post_id) {
			$custom_fields = get_post_custom( $post_id );
			$pung = array();
	
			if( is_array( $custom_fields ) ) {
				while( list( $key, $val ) = each( $custom_fields ) ) { 
					if( $key == 'com-enclosure' ) {
						if (is_array($val)) {
							foreach($val as $enc) {
								$enclosure = split( "\n", $enc );
								if (trim($enclosure[0]) == $comment_id) {
								  $pung[] = trim( $enclosure[0] );
								}
							}
						}
					}
				}
			}
			return $pung;
		}


		// Get enclosures already enclosed for a comment
		function getCommentEnclosure($comment_ID, $post_ID) {
			$enclosureTag = '';
			$custom_fields = get_post_custom( $post_ID );
			$pung = array();
	
			if( is_array( $custom_fields ) ) {
				while( list( $key, $val ) = each( $custom_fields ) ) { 
					if( $key == 'com-enclosure' ) {
						if (is_array($val)) {
							foreach($val as $enc) {
								$enclosure = split( "\n", $enc );
								if (trim($enclosure[0]) == $comment_ID) {
								  $enclosureTag = '<enclosure url="'.$enclosure[1].'" length="'.$enclosure[2].'" type="'.$enclosure[3].'" />';
								}
							}
						}
					}
				}
			}
			return $enclosureTag;
		}

		function itunesCategoryOptions($current = '') {
			$cats = array();

			$cats['Arts & Entertainment'] = 'Arts & Entertainment';
			$cats['Arts & Entertainment:Architecture'] = 'Arts & Entertainment:Architecture';
			$cats['Arts & Entertainment:Books'] = 'Arts & Entertainment:Books';
			$cats['Arts & Entertainment:Design'] = 'Arts & Entertainment:Design';
			$cats['Arts & Entertainment:Entertainment'] = 'Arts & Entertainment:Entertainment';
			$cats['Arts & Entertainment:Games'] = 'Arts & Entertainment:Games';
			$cats['Arts & Entertainment:Performing Arts'] = 'Arts & Entertainment:Performing Arts';
			$cats['Arts & Entertainment:Photography'] = 'Arts & Entertainment:Photography';
			$cats['Arts & Entertainment:Science Fiction'] = 'Arts & Entertainment:Science Fiction';

			$cats['Audio Blogs'] = 'Audio Blogs';

			$cats['Business'] = 'Business';
			$cats['Business:Careers'] = 'Business:Careers';
			$cats['Business:Finance'] = 'Business:Finance';
			$cats['Business:Investing'] = 'Business:Investing';
			$cats['Business:Management'] = 'Business:Management';
			$cats['Business:Marketing'] = 'Business:Marketing';

			$cats['Comedy'] = 'Comedy';

			$cats['Education'] = 'Education';
			$cats['Education:K-12'] = 'Education:K-12';
			$cats['Education:Higher Education'] = 'Education:Higher Education';

			$cats['Food'] = 'Food';

			$cats['Health'] = 'Health';
			$cats['Health:Diet & Nutrition'] = 'Health:Diet & Nutrition';
			$cats['Health:Fitness'] = 'Health:Fitness';
			$cats['Health:Relationships'] = 'Health:Relationships';
			$cats['Health:Self-Help'] = 'Health:Self-Help';
			$cats['Health:Sexuality'] = 'Health:Sexuality';

			$cats['International'] = 'International';
			$cats['International:Australian'] = 'International:Australian';
			$cats['International:Belgian'] = 'International:Belgian';
			$cats['International:Brazilian'] = 'International:Brazilian';
			$cats['International:Canadian'] = 'International:Canadian';
			$cats['International:Chinese'] = 'International:Chinese';
			$cats['International:Dutch'] = 'International:Dutch';
			$cats['International:French'] = 'International:French';
			$cats['International:German'] = 'International:German';
			$cats['International:Hebrew'] = 'International:Hebrew';
			$cats['International:Italian'] = 'International:Italian';
			$cats['International:Japanese'] = 'International:Japanese';
			$cats['International:Norwegian'] = 'International:Norwegian';
			$cats['International:Polish'] = 'International:Polish';
			$cats['International:Portuguese'] = 'International:Portuguese';
			$cats['International:Spanish'] = 'International:Spanish';
			$cats['International:Swedish'] = 'International:Swedish';

			$cats['Movies & Television'] = 'Movies & Television';
			$cats['Movies & Television:News'] = 'Movies & Television:News';
			$cats['Movies & Television:Politics'] = 'Movies & Television:Politics';
			$cats['Movies & Television:Public Radio'] = 'Movies & Television:Public Radio';

			$cats['Music'] = 'Music';

			$cats['Religion & Spirituality'] = 'Religion & Spirituality';
			$cats['Religion & Spirituality:Buddhism'] = 'Religion & Spirituality:Buddhism';
			$cats['Religion & Spirituality:Christianity'] = 'Religion & Spirituality:Christianity';
			$cats['Religion & Spirituality:Islam'] = 'Religion & Spirituality:Islam';
			$cats['Religion & Spirituality:Judaism'] = 'Religion & Spirituality:Judaism';
			$cats['Religion & Spirituality:New Age'] = 'Religion & Spirituality:New Age';
			$cats['Religion & Spirituality:Philosophy'] = 'Religion & Spirituality:Philosophy';
			$cats['Religion & Spirituality:Spirituality'] = 'Religion & Spirituality:Spirituality';

			$cats['Science'] = 'Science';

			$cats['Sports'] = 'Sports';

			$cats['Talk Radio'] = 'Talk Radio';

			$cats['Technology'] = 'Technology';
			$cats['Technology:Computers'] = 'Technology:Computers';
			$cats['Technology:Developers'] = 'Technology:Developers';
			$cats['Technology:Gadgets'] = 'Technology:Gadgets';
			$cats['Technology:Information'] = 'Technology:Information';
			$cats['Technology:News'] = 'Technology:News';
			$cats['Technology:Operating Systems'] = 'Technology:Operating Systems';
			$cats['Technology:Podcasting'] = 'Technology:Podcasting';
			$cats['Technology:Smart Phones'] = 'Technology:Smart Phones';
			$cats['Technology:Text/Speech'] = 'Technology:Text/Speech';

			$cats['Travel'] = 'Travel';
	
			reset($cats);
	
			foreach ($cats as $key => $value) {
				echo '<option value="'.$key.'"';
				if($key == $current) {
					echo ' selected="selected"';
				}
				echo ';>'.$value.'</option>'."\n";
			}
		}
	// *** End of podPress Class ***
	}


	/*************************************************************/
	/* !!! BEGINNING OF THE ACTION !!!                           */
	/*************************************************************/
	
	/*************************************************************/
	/* Create the podPress object                                */
	/*************************************************************/
	
	$GLOBALS['podPress'] = new podPress();

	/*************************************************************/
	/* Simple wrapper functions, since I dont think I can        */
	/* register object functions                                 */
	/*************************************************************/
	function podPress_insert_player_widgets($content = '')
	{
		return $GLOBALS['podPress']->insert_player_widgets($content);
	}

	function podPress_replace($matches)
	{
		return $GLOBALS['podPress']->replace($matches);
	}

	function podPress_form()
	{
		return $GLOBALS['podPress']->showForm();
	}

	function podPress_save_post($post_id)
	{
		return $GLOBALS['podPress']->save_post($post_id);
	}

	function podPress_comment_do_enclose($comment_ID)
	{
		return $GLOBALS['podPress']->comment_do_enclose($comment_ID);
	}

	/*************************************************************/
	/* Register load blog crap                                   */
	/*************************************************************/
	
	add_filter('the_content', 'podPress_insert_player_widgets');
	add_filter('the_content_rss', 'podPress_insert_player_widgets');

	if(isset($_POST['submitted'])) { $GLOBALS['podPress']->process(); }


	/* Add podPress Tab to Options Menu */
	function podPress_add_options_page() {
		if (function_exists('add_options_page')) { 
			add_options_page('podPress Configuration', 'PodPress', 5, basename(__FILE__)); 
//			add_submenu_page('post.php','test', 'test_title', 0, 'testfile');
		}
	}

	/* If this is an admin page, run the function to Add podPress Tab to Options Menu */
	add_action('admin_head', 'podPress_add_options_page');

	// IF NOT, RUN EVERYTHING ELSE
	add_action('simple_edit_form','podPress_form');	// DISPLAYS THE FORM IN THE SIMPLE FORM
	add_action('edit_form_advanced','podPress_form');	// DISPLAYS THE FORM IN THE ADVANCED FORM
	add_action('save_post','podPress_save_post');		// UPDATES AND SAVES THE POST
	add_action('edit_post','podPress_save_post');		// UPDATES AND SAVES THE POST

	if (get_option('itunesCommentCast') == "yes") {
		add_action('comment_post','podPress_comment_do_enclose');  // CHECKS THE COMMENT FOR ENCLOSURES
		add_action('edit_comment','podPress_comment_do_enclose');	 // CHECKS AN UPDATED COMMENT FOR ENCLOSURES
	}

}
